#ifndef ANGLE_H
#define ANGLE_H

#include <wx/string.h>

class Angle
{
public:
	double radians;

	enum Unit
	{
		Rad,
		Deg
	};

	Angle(double value = 0., Unit unit = Rad);

	double getDegrees() const;
	void setDegrees(double value);

	static Angle abs(const Angle &a);
	static bool isNaN(Angle &a);
	bool isNaN() const;

	bool operator==(const Angle &a) const;
	bool operator!=(const Angle &a) const;
	bool operator<(const Angle &a) const;
	bool operator>(const Angle &a) const;
	Angle operator+(const Angle &a) const;
	Angle operator-(const Angle &a) const;
	Angle& operator+=(const Angle &a);
	Angle& operator-=(const Angle &a);
	Angle operator*(double times) const;
	friend Angle operator*(double times, Angle &a);
	friend Angle operator/(double divisor, Angle &a);
	Angle operator/(double divisor) const;

	static double degreesToRadians(double degrees);
	static double radiansToDegrees(double radians);
};

#endif // ANGLE_H
