#ifndef QUATERNION_H
#define QUATERNION_H

class Vector;

class Quaternion
{
public:
	union
	{
		struct
		{
			double x;
			double y;
			double z;
			double w;
		};
		double val[4];
	};

	Quaternion(double x = 0., double y = 0., double z = 0., double w = 1.);

	Quaternion(const Vector &axis, double angle);
	void set(const Vector &axis, double angle);

	Quaternion & operator+=(const Quaternion &q);
	Quaternion  operator-() const;
	Quaternion operator+(const Quaternion &q) const;
	Quaternion operator-(const Quaternion &q) const;
	Quaternion operator*(const Quaternion &q) const;
	Quaternion & operator*=(const Quaternion &q);
	Quaternion operator*(double s) const;
	Quaternion operator/(double s) const;
	Vector operator*(const Vector &v) const;

	double squaredNorm() const;
	double norm() const;
	void normalize();
	Quaternion normalized() const;
};
#endif //QUATERNION_H
